#!/usr/bin/python

""" Simple script for stretching the x-coordinates of a .grd file as 
    found in the chdk extension for CANON digital cameras. Newer cameras 
    seem to have the habit of displaying the available grid overlays only 
    on the left half of the display. This script takes a grid file and 
    stretches its x-coordinates by a factor of 2. Attention: the new file is
    written under the same name as the old one, effectively overwriting it.

    Usage: ./chdk_gridstretch_0.2.py filename  

"""

import re
from  sys import argv

file     = open(argv[1])
lines    = file.readlines()
file.close()
file     = open(argv[1],"w")

for i in range(len(lines)):
   if (i == 0):
      file.write(lines[0])
      continue
   if (lines[i][0] == "#"):
      file.write(lines[i])
      continue
   words = re.split(r"[\s\.,\?]+",lines[i])
   words = words[0:-1]
   if (len(words) == 0 or len(words) == 1):
      file.write("\n")
      continue
   outline = ""
   for j in range(len(words)):
      if (j == 0):
         outline = words[0] + " "
      elif (j == 1 or j == 3):
         words[j]=str(2*int(words[j]))
         outline = outline + words[j] + ", "
      elif (j == len(words)-1):
         outline = outline + words[j] 
      else: 
         outline = outline + words[j] + ", "
   file.write(outline+"\n")
file.close()
